package examples;

import uk.ac.ukc.cs.kmf.ocl.implementations.OCL;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.AS.Internal.IContour;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.AS.Internal.IContourLifecycle;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.AS.Internal.IDiagram;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.AS.Internal.IZone;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.repository.implementation.ConstraintDiagramsRepository;
import uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.startup.implementation.ConstraintDiagramsStartup;

public class Venn2ExampleToolgen extends ConstraintDiagramsStartup
{
    //--- Create SpiderDiagramrepository ---
    
    String ASIpath = "uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.AS.Internal.";
    String ASEpath = "uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.AS.External.";
    

    protected void replaceDefaultLifecycles() {
//        rep.addLifecycle(ASIpath+"Diagram", new lifecycle.AbstractDiagram(rep));    	        
    }
    
    //--- Populate repository ---
    protected void initialisePopulation() {
        IContourLifecycle contour_lc = (IContourLifecycle)(rep.getLifecycle(ASIpath+"Contour"));

        IDiagram ad = (IDiagram)rep.buildElement(ASIpath+"Diagram");

    	IContour c1 = (IContour)contour_lc.build();
    	IContour c2 = (IContour)contour_lc.build();
    	IContour c3 = (IContour)contour_lc.build();

        IZone z1 = (IZone)rep.buildElement(ASIpath+"Zone");
        IZone z2 = (IZone)rep.buildElement(ASIpath+"Zone");
        IZone z3 = (IZone)rep.buildElement(ASIpath+"Zone");
        IZone z4 = (IZone)rep.buildElement(ASIpath+"Zone");   	

    	c1.setDiagram(ad);
    	c1.setLabel(OCL.String("A&B"));
    	c1.setBasicRegion(z1);
    	ad.contour().add(c1);

    	c2.setLabel(OCL.String("A"));
    	c2.setDiagram(ad);
    	c2.setBasicRegion(z3);
    	ad.contour().add(c2);

    	c3.setLabel(OCL.String("B"));
    	c3.setDiagram(ad);
    	c3.setBasicRegion(z3);
    	ad.contour().add(c3);

        z1.setDiagram(ad);
        z1.setContour(c1);
        z1.containingContour().add(c1);
        z1.containingContour().add(c2);        
        z1.containingContour().add(c3);        
        z1.containingRegion().add(z1);        
        z1.containingRegion().add(z2);        
        z1.containingRegion().add(z3);        
        z1.containingRegion().add(z4);
        z1.containedZone().add(z1);
        ad.zone().add(z1);

        z2.setDiagram(ad);
        z2.setContour(c2);
        z2.containingContour().add(c2);
        z2.containingRegion().add(z2);        
        z2.containingRegion().add(z4);        
        z2.containedZone().add(z2);
        z2.containedZone().add(z1);
        z2.setContour(c1);
        ad.zone().add(z2);

        z3.setDiagram(ad);
        z3.setContour(c3);
        z3.containingContour().add(c1);
        z3.containingRegion().add(z3);        
        z3.containingRegion().add(z4);        
        z3.containedZone().add(z3);
        z3.containedZone().add(z1);
        z3.setContour(c2);
        ad.zone().add(z3);

        z4.setDiagram(ad);
        z4.containingRegion().add(z4);        
        z4.containedZone().add(z1);
        z4.containedZone().add(z2);
        z4.containedZone().add(z3);
        z4.containedZone().add(z4);
        ad.zone().add(z4);
    }
    //--- Main ---
    public static void main(String args[]) {
        (new Venn2ExampleToolgen()).run(new ConstraintDiagramsRepository());
    }
}
