/**
 *
 *  Class ConstraintDiagramsOCLEvaluator.java
 *
 *  Generated by KMF [ToolGen] at 30 April 2003 10:26:36
 *  Visit http://www.cs.ukc.ac.uk/kmf
 *
 */

package uk.ac.ukc.cs.toolgen.rwd.ConstraintDiagrams.repository.implementation;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import javax.swing.AbstractAction;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JInternalFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.EmptyBorder;

import uk.ac.ukc.cs.kmf.ocl.IOclExpression;
import uk.ac.ukc.cs.kmf.ocl.exceptions.ParserException;
import uk.ac.ukc.cs.kmf.ocl.implementations.OCL;

public class ConstraintDiagramsOCLEvaluator
    extends JInternalFrame
{

    //--- CONTEXT ---
    protected Map context = new HashMap();
    //--- INPUT and OUTPUT text area ---
    protected JTextArea expressionText;
    protected JTextArea evaluationText;
    //--- EVALUATE button ---
    protected JButton evaluateButton;

    //--- Construct evaluator ---
    public ConstraintDiagramsOCLEvaluator(Map context) {
        //--- Set CONTEXT ---
        this.context = context;
	     String strContext = "context:\n";
	     Iterator i = context.entrySet().iterator();
	     while (i.hasNext()) {
	         Map.Entry me = (Map.Entry)i.next();
	         strContext+="  "+(String)me.getKey()+" : "+me.getValue().toString()+"\n";
	     }

        //--- Frame settings ---
        setTitle("OCL Evaluator ["+strContext+"]");
        setResizable(true);
        setClosable(true);
        setMaximizable(true);
        setIconifiable(true);

        //--- Panel settings ---
        JPanel mainPanel = new JPanel();
        mainPanel.setBorder(new EmptyBorder(new Insets(10, 10, 10, 10)));
        mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS) );

        //--- Add INPUT ---
        expressionText = new JTextArea();
        expressionText.setLineWrap(true);
        expressionText.setRows(5);
        mainPanel.add(new JScrollPane(expressionText, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER));

        //--- Add EVALUATE BUTTON ---
        evaluateButton = new JButton(new AbstractAction("Evaluate") {
            public void actionPerformed(ActionEvent e) {
                evaluateAction(e);
            }
        });
        evaluateButton.setAlignmentX(CENTER_ALIGNMENT);
        mainPanel.add(evaluateButton);

        //--- Add OUTPUT ---
        evaluationText = new JTextArea();
        evaluationText.setRows(5);
        evaluationText.setLineWrap(true);
        mainPanel.add(new JScrollPane(evaluationText, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER));

        //--- Add the mainPanel ---
        setContentPane(new JScrollPane(mainPanel));
        pack();
    }

    //--- Evaluate action ---
    protected void evaluateAction(ActionEvent e) {
        String es = expressionText.getText();
        try {
            IOclExpression expr = OCL.Expression(es, context);
            evaluationText.setText(expr.evaluate().toString());
        } catch(ParserException e1) {
            evaluationText.setText("syntax error\n");
        } catch(Exception e1) {
            evaluationText.setText("undefined\n");
        }
    }
}
