/**
 *
 *  Class ConstraintDiagramsEvaluateAllVisitor.java
 *
 *  Generated by KMFStudio at 22 May 2003 20:32:41
 *  Visit http://www.cs.ukc.ac.uk/kmf
 *
 */

package uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams;

import java.util.Map;

import uk.ac.ukc.cs.kmf.ocl20.Evaluation.Stdlib.IOclBoolean;
import uk.ac.ukc.cs.kmf.ocl20.Evaluation.Stdlib.IOclInteger;
import uk.ac.ukc.cs.kmf.ocl20.Evaluation.Stdlib.IOclSet;
import uk.ac.ukc.cs.kmf.ocl20.Evaluation.Stdlib.OCL;
import uk.ac.ukc.cs.kmf.util.ILog;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.Collection_;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.Relation;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Arrow;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Contour;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Diagram;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Region;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.RelationRestriction;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Zone;

public class ConstraintDiagramsEvaluateAllVisitor$Class
	extends ConstraintDiagramsVisitor$Class
	implements ConstraintDiagramsEvaluateAllVisitor
{
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Region' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Region self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Region inv contour_bidirectional: contour.basicRegion=self";
			log.printMessage("  "+invariant);

			//--- Print result ---
			Contour t243 = (Contour)self.getContour();
			Region t244 = (Region)t243.getBasicRegion();
			IOclBoolean t245 = OCL.equalTo(t244, self);
			log.reportMessage(": "+t245);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Region inv containedZone_size: 0<=containedZone->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t246 = OCL.Set(self.getContainedZone());
			IOclInteger t247 = (IOclInteger)t246.size();
			IOclBoolean t248 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t247);
			log.reportMessage(": "+t248);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Region inv containedZone_bidirectional: containedZone->forAll(x | x.containingRegion->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t249 = OCL.Set(self.getContainedZone());
			Zone x = null;
			IOclBoolean t250 = OCL.Boolean(true);
			java.util.Iterator t251 = OCL.impl(t249).iterator();
			while (t251.hasNext()) {
			    x = (Zone)t251.next();
			    IOclSet t252 = OCL.Set(x.getContainingRegion());
			    IOclBoolean t253 = (IOclBoolean)t252.includes(self);
			    t250 = t253;
			    if(!OCL.impl(t250)) break;
			}
			log.reportMessage(": "+t250);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Region inv collection_bidirectional: Set{collection}->forAll(x | x.region->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t254 = OCL.Set();
			Collection_ t255 = (Collection_)self.getCollection();
			t254 = t254.including(t255);
			Collection_ x = null;
			IOclBoolean t256 = OCL.Boolean(true);
			java.util.Iterator t257 = OCL.impl(t254).iterator();
			while (t257.hasNext()) {
			    x = (Collection_)t257.next();
			    IOclSet t258 = OCL.Set(x.getRegion());
			    IOclBoolean t259 = (IOclBoolean)t258.includes(self);
			    t256 = t259;
			    if(!OCL.impl(t256)) break;
			}
			log.reportMessage(": "+t256);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Zone' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Zone self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv contour_bidirectional: contour.basicRegion=self";
			log.printMessage("  "+invariant);

			//--- Print result ---
			Contour t260 = (Contour)self.getContour();
			Region t261 = (Region)t260.getBasicRegion();
			IOclBoolean t262 = OCL.equalTo(t261, self);
			log.reportMessage(": "+t262);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv containedZone_size: 0<=containedZone->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t263 = OCL.Set(self.getContainedZone());
			IOclInteger t264 = (IOclInteger)t263.size();
			IOclBoolean t265 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t264);
			log.reportMessage(": "+t265);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv containedZone_bidirectional: containedZone->forAll(x | x.containingRegion->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t266 = OCL.Set(self.getContainedZone());
			Zone x = null;
			IOclBoolean t267 = OCL.Boolean(true);
			java.util.Iterator t268 = OCL.impl(t266).iterator();
			while (t268.hasNext()) {
			    x = (Zone)t268.next();
			    IOclSet t269 = OCL.Set(x.getContainingRegion());
			    IOclBoolean t270 = (IOclBoolean)t269.includes(self);
			    t267 = t270;
			    if(!OCL.impl(t267)) break;
			}
			log.reportMessage(": "+t267);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv collection_bidirectional: Set{collection}->forAll(x | x.region->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t271 = OCL.Set();
			Collection_ t272 = (Collection_)self.getCollection();
			t271 = t271.including(t272);
			Collection_ x = null;
			IOclBoolean t273 = OCL.Boolean(true);
			java.util.Iterator t274 = OCL.impl(t271).iterator();
			while (t274.hasNext()) {
			    x = (Collection_)t274.next();
			    IOclSet t275 = OCL.Set(x.getRegion());
			    IOclBoolean t276 = (IOclBoolean)t275.includes(self);
			    t273 = t276;
			    if(!OCL.impl(t273)) break;
			}
			log.reportMessage(": "+t273);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv diagram_bidirectional: Set{diagram}->forAll(x | x.zone->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t277 = OCL.Set();
			Diagram t278 = (Diagram)self.getDiagram();
			t277 = t277.including(t278);
			Diagram x = null;
			IOclBoolean t279 = OCL.Boolean(true);
			java.util.Iterator t280 = OCL.impl(t277).iterator();
			while (t280.hasNext()) {
			    x = (Diagram)t280.next();
			    IOclSet t281 = OCL.Set(x.getZone());
			    IOclBoolean t282 = (IOclBoolean)t281.includes(self);
			    t279 = t282;
			    if(!OCL.impl(t279)) break;
			}
			log.reportMessage(": "+t279);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv containingRegion_size: 1<=containingRegion->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t283 = OCL.Set(self.getContainingRegion());
			IOclInteger t284 = (IOclInteger)t283.size();
			IOclBoolean t285 = (IOclBoolean)OCL.Integer(1).lessThanOrEqualTo(t284);
			log.reportMessage(": "+t285);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv containingRegion_bidirectional: containingRegion->forAll(x | x.containedZone->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t286 = OCL.Set(self.getContainingRegion());
			Region x = null;
			IOclBoolean t287 = OCL.Boolean(true);
			java.util.Iterator t288 = OCL.impl(t286).iterator();
			while (t288.hasNext()) {
			    x = (Region)t288.next();
			    IOclSet t289 = OCL.Set(x.getContainedZone());
			    IOclBoolean t290 = (IOclBoolean)t289.includes(self);
			    t287 = t290;
			    if(!OCL.impl(t287)) break;
			}
			log.reportMessage(": "+t287);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Zone inv containingContour_size: 0<=containingContour->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t291 = OCL.Set(self.getContainingContour());
			IOclInteger t292 = (IOclInteger)t291.size();
			IOclBoolean t293 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t292);
			log.reportMessage(": "+t293);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Diagram' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Diagram self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv spider_size: 0<=spider->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t294 = OCL.Set(self.getSpider());
			IOclInteger t295 = (IOclInteger)t294.size();
			IOclBoolean t296 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t295);
			log.reportMessage(": "+t296);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv contour_size: 1<=contour->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t297 = OCL.Set(self.getContour());
			IOclInteger t298 = (IOclInteger)t297.size();
			IOclBoolean t299 = (IOclBoolean)OCL.Integer(1).lessThanOrEqualTo(t298);
			log.reportMessage(": "+t299);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv contour_bidirectional: contour->forAll(x | x.diagram=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t300 = OCL.Set(self.getContour());
			Contour x = null;
			IOclBoolean t301 = OCL.Boolean(true);
			java.util.Iterator t302 = OCL.impl(t300).iterator();
			while (t302.hasNext()) {
			    x = (Contour)t302.next();
			    Diagram t303 = (Diagram)x.getDiagram();
			    IOclBoolean t304 = OCL.equalTo(t303, self);
			    t301 = t304;
			    if(!OCL.impl(t301)) break;
			}
			log.reportMessage(": "+t301);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv zone_size: 1<=zone->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t305 = OCL.Set(self.getZone());
			IOclInteger t306 = (IOclInteger)t305.size();
			IOclBoolean t307 = (IOclBoolean)OCL.Integer(1).lessThanOrEqualTo(t306);
			log.reportMessage(": "+t307);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv zone_bidirectional: zone->forAll(x | x.diagram=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t308 = OCL.Set(self.getZone());
			Zone x = null;
			IOclBoolean t309 = OCL.Boolean(true);
			java.util.Iterator t310 = OCL.impl(t308).iterator();
			while (t310.hasNext()) {
			    x = (Zone)t310.next();
			    Diagram t311 = (Diagram)x.getDiagram();
			    IOclBoolean t312 = OCL.equalTo(t311, self);
			    t309 = t312;
			    if(!OCL.impl(t309)) break;
			}
			log.reportMessage(": "+t309);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv arrow_size: 0<=arrow->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t313 = OCL.Set(self.getArrow());
			IOclInteger t314 = (IOclInteger)t313.size();
			IOclBoolean t315 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t314);
			log.reportMessage(": "+t315);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Diagram inv arrow_bidirectional: arrow->forAll(x | x.diagram=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t316 = OCL.Set(self.getArrow());
			Arrow x = null;
			IOclBoolean t317 = OCL.Boolean(true);
			java.util.Iterator t318 = OCL.impl(t316).iterator();
			while (t318.hasNext()) {
			    x = (Arrow)t318.next();
			    Diagram t319 = (Diagram)x.getDiagram();
			    IOclBoolean t320 = OCL.equalTo(t319, self);
			    t317 = t320;
			    if(!OCL.impl(t317)) break;
			}
			log.reportMessage(": "+t317);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.ContourKind' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.ContourKind self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Spider' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Spider self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.RelationRestriction' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.RelationRestriction self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv range_bidirectional: Set{range}->forAll(x | x.rangeOf->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t321 = OCL.Set();
			Collection_ t322 = (Collection_)self.getRange();
			t321 = t321.including(t322);
			Collection_ x = null;
			IOclBoolean t323 = OCL.Boolean(true);
			java.util.Iterator t324 = OCL.impl(t321).iterator();
			while (t324.hasNext()) {
			    x = (Collection_)t324.next();
			    IOclSet t325 = OCL.Set(x.getRangeOf());
			    IOclBoolean t326 = (IOclBoolean)t325.includes(self);
			    t323 = t326;
			    if(!OCL.impl(t323)) break;
			}
			log.reportMessage(": "+t323);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv restriction_size: 0<=restriction->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t327 = OCL.Set(self.getRestriction());
			IOclInteger t328 = (IOclInteger)t327.size();
			IOclBoolean t329 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t328);
			log.reportMessage(": "+t329);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv restriction_bidirectional: restriction->forAll(x | x.restrictedProperty->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t330 = OCL.Set(self.getRestriction());
			RelationRestriction x = null;
			IOclBoolean t331 = OCL.Boolean(true);
			java.util.Iterator t332 = OCL.impl(t330).iterator();
			while (t332.hasNext()) {
			    x = (RelationRestriction)t332.next();
			    IOclSet t333 = OCL.Set(x.getRestrictedProperty());
			    IOclBoolean t334 = (IOclBoolean)t333.includes(self);
			    t331 = t334;
			    if(!OCL.impl(t331)) break;
			}
			log.reportMessage(": "+t331);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv domain_bidirectional: Set{domain}->forAll(x | x.domainOf->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t335 = OCL.Set();
			Collection_ t336 = (Collection_)self.getDomain();
			t335 = t335.including(t336);
			Collection_ x = null;
			IOclBoolean t337 = OCL.Boolean(true);
			java.util.Iterator t338 = OCL.impl(t335).iterator();
			while (t338.hasNext()) {
			    x = (Collection_)t338.next();
			    IOclSet t339 = OCL.Set(x.getDomainOf());
			    IOclBoolean t340 = (IOclBoolean)t339.includes(self);
			    t337 = t340;
			    if(!OCL.impl(t337)) break;
			}
			log.reportMessage(": "+t337);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv restrictedProperty_size: 1<=restrictedProperty->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t341 = OCL.Set(self.getRestrictedProperty());
			IOclInteger t342 = (IOclInteger)t341.size();
			IOclBoolean t343 = (IOclBoolean)OCL.Integer(1).lessThanOrEqualTo(t342);
			log.reportMessage(": "+t343);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv restrictedProperty_bidirectional: restrictedProperty->forAll(x | x.restriction->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t344 = OCL.Set(self.getRestrictedProperty());
			Relation x = null;
			IOclBoolean t345 = OCL.Boolean(true);
			java.util.Iterator t346 = OCL.impl(t344).iterator();
			while (t346.hasNext()) {
			    x = (Relation)t346.next();
			    IOclSet t347 = OCL.Set(x.getRestriction());
			    IOclBoolean t348 = (IOclBoolean)t347.includes(self);
			    t345 = t348;
			    if(!OCL.impl(t345)) break;
			}
			log.reportMessage(": "+t345);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv arrow_size: 0<=arrow->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t349 = OCL.Set(self.getArrow());
			IOclInteger t350 = (IOclInteger)t349.size();
			IOclBoolean t351 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t350);
			log.reportMessage(": "+t351);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::RelationRestriction inv arrow_bidirectional: arrow->forAll(x | x.restriction=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t352 = OCL.Set(self.getArrow());
			Arrow x = null;
			IOclBoolean t353 = OCL.Boolean(true);
			java.util.Iterator t354 = OCL.impl(t352).iterator();
			while (t354.hasNext()) {
			    x = (Arrow)t354.next();
			    RelationRestriction t355 = (RelationRestriction)x.getRestriction();
			    IOclBoolean t356 = OCL.equalTo(t355, self);
			    t353 = t356;
			    if(!OCL.impl(t353)) break;
			}
			log.reportMessage(": "+t353);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.CollectionKind' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.CollectionKind self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Arrow' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Arrow self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Arrow inv diagram_bidirectional: Set{diagram}->forAll(x | x.arrow->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t357 = OCL.Set();
			Diagram t358 = (Diagram)self.getDiagram();
			t357 = t357.including(t358);
			Diagram x = null;
			IOclBoolean t359 = OCL.Boolean(true);
			java.util.Iterator t360 = OCL.impl(t357).iterator();
			while (t360.hasNext()) {
			    x = (Diagram)t360.next();
			    IOclSet t361 = OCL.Set(x.getArrow());
			    IOclBoolean t362 = (IOclBoolean)t361.includes(self);
			    t359 = t362;
			    if(!OCL.impl(t359)) break;
			}
			log.reportMessage(": "+t359);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Arrow inv restriction_bidirectional: Set{restriction}->forAll(x | x.arrow->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t363 = OCL.Set();
			RelationRestriction t364 = (RelationRestriction)self.getRestriction();
			t363 = t363.including(t364);
			RelationRestriction x = null;
			IOclBoolean t365 = OCL.Boolean(true);
			java.util.Iterator t366 = OCL.impl(t363).iterator();
			while (t366.hasNext()) {
			    x = (RelationRestriction)t366.next();
			    IOclSet t367 = OCL.Set(x.getArrow());
			    IOclBoolean t368 = (IOclBoolean)t367.includes(self);
			    t365 = t368;
			    if(!OCL.impl(t365)) break;
			}
			log.reportMessage(": "+t365);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.SpiderKind' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.SpiderKind self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.ArrowEnd' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.ArrowEnd self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Contour' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.Internal.Contour self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Contour inv diagram_bidirectional: Set{diagram}->forAll(x | x.contour->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t369 = OCL.Set();
			Diagram t370 = (Diagram)self.getDiagram();
			t369 = t369.including(t370);
			Diagram x = null;
			IOclBoolean t371 = OCL.Boolean(true);
			java.util.Iterator t372 = OCL.impl(t369).iterator();
			while (t372.hasNext()) {
			    x = (Diagram)t372.next();
			    IOclSet t373 = OCL.Set(x.getContour());
			    IOclBoolean t374 = (IOclBoolean)t373.includes(self);
			    t371 = t374;
			    if(!OCL.impl(t371)) break;
			}
			log.reportMessage(": "+t371);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::Internal::Contour inv basicRegion_bidirectional: basicRegion.contour = self";
			log.printMessage("  "+invariant);

			//--- Print result ---
			Region t375 = (Region)self.getBasicRegion();
			Contour t376 = (Contour)t375.getContour();
			IOclBoolean t377 = OCL.equalTo(t376, self);
			log.reportMessage(": "+t377);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.Collection_' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.Collection_ self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::External::Collection_ inv rangeOf_size: 0<=rangeOf->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t378 = OCL.Set(self.getRangeOf());
			IOclInteger t379 = (IOclInteger)t378.size();
			IOclBoolean t380 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t379);
			log.reportMessage(": "+t380);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Collection_ inv rangeOf_bidirectional: rangeOf->forAll(x | x.range=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t381 = OCL.Set(self.getRangeOf());
			Relation x = null;
			IOclBoolean t382 = OCL.Boolean(true);
			java.util.Iterator t383 = OCL.impl(t381).iterator();
			while (t383.hasNext()) {
			    x = (Relation)t383.next();
			    Collection_ t384 = (Collection_)x.getRange();
			    IOclBoolean t385 = OCL.equalTo(t384, self);
			    t382 = t385;
			    if(!OCL.impl(t382)) break;
			}
			log.reportMessage(": "+t382);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Collection_ inv region_size: 0<=region->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t386 = OCL.Set(self.getRegion());
			IOclInteger t387 = (IOclInteger)t386.size();
			IOclBoolean t388 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t387);
			log.reportMessage(": "+t388);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Collection_ inv region_bidirectional: region->forAll(x | x.collection=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t389 = OCL.Set(self.getRegion());
			Region x = null;
			IOclBoolean t390 = OCL.Boolean(true);
			java.util.Iterator t391 = OCL.impl(t389).iterator();
			while (t391.hasNext()) {
			    x = (Region)t391.next();
			    Collection_ t392 = (Collection_)x.getCollection();
			    IOclBoolean t393 = OCL.equalTo(t392, self);
			    t390 = t393;
			    if(!OCL.impl(t390)) break;
			}
			log.reportMessage(": "+t390);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Collection_ inv domainOf_size: 0<=domainOf->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t394 = OCL.Set(self.getDomainOf());
			IOclInteger t395 = (IOclInteger)t394.size();
			IOclBoolean t396 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t395);
			log.reportMessage(": "+t396);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Collection_ inv domainOf_bidirectional: domainOf->forAll(x | x.domain=self)";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t397 = OCL.Set(self.getDomainOf());
			Relation x = null;
			IOclBoolean t398 = OCL.Boolean(true);
			java.util.Iterator t399 = OCL.impl(t397).iterator();
			while (t399.hasNext()) {
			    x = (Relation)t399.next();
			    Collection_ t400 = (Collection_)x.getDomain();
			    IOclBoolean t401 = OCL.equalTo(t400, self);
			    t398 = t401;
			    if(!OCL.impl(t398)) break;
			}
			log.reportMessage(": "+t398);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
	/** Visit class 'uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.Relation' */
	public Object visit(uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.AS.External.Relation self, Object data) {
		//--- Unpack arguments ---
		ILog log = (ILog)((Map)data).get("log");
		//--- Common variables ---
		String invariant;
		log.reportMessage("Evaluating invariants for "+self+"...");
		try {
			//--- Print invariant ---
			invariant = "context AS::External::Relation inv range_bidirectional: Set{range}->forAll(x | x.rangeOf->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t402 = OCL.Set();
			Collection_ t403 = (Collection_)self.getRange();
			t402 = t402.including(t403);
			Collection_ x = null;
			IOclBoolean t404 = OCL.Boolean(true);
			java.util.Iterator t405 = OCL.impl(t402).iterator();
			while (t405.hasNext()) {
			    x = (Collection_)t405.next();
			    IOclSet t406 = OCL.Set(x.getRangeOf());
			    IOclBoolean t407 = (IOclBoolean)t406.includes(self);
			    t404 = t407;
			    if(!OCL.impl(t404)) break;
			}
			log.reportMessage(": "+t404);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Relation inv restriction_size: 0<=restriction->size()";
			log.printMessage("  "+invariant);

			//--- Print result ---
			IOclSet t408 = OCL.Set(self.getRestriction());
			IOclInteger t409 = (IOclInteger)t408.size();
			IOclBoolean t410 = (IOclBoolean)OCL.Integer(0).lessThanOrEqualTo(t409);
			log.reportMessage(": "+t410);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Relation inv restriction_bidirectional: restriction->forAll(x | x.restrictedProperty->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t411 = OCL.Set(self.getRestriction());
			RelationRestriction x = null;
			IOclBoolean t412 = OCL.Boolean(true);
			java.util.Iterator t413 = OCL.impl(t411).iterator();
			while (t413.hasNext()) {
			    x = (RelationRestriction)t413.next();
			    IOclSet t414 = OCL.Set(x.getRestrictedProperty());
			    IOclBoolean t415 = (IOclBoolean)t414.includes(self);
			    t412 = t415;
			    if(!OCL.impl(t412)) break;
			}
			log.reportMessage(": "+t412);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}

		try {
			//--- Print invariant ---
			invariant = "context AS::External::Relation inv domain_bidirectional: Set{domain}->forAll(x | x.domainOf->includes(self))";
			log.printMessage("  "+invariant);

			//--- Print result ---
			// 'forAll' iterator
			IOclSet t416 = OCL.Set();
			Collection_ t417 = (Collection_)self.getDomain();
			t416 = t416.including(t417);
			Collection_ x = null;
			IOclBoolean t418 = OCL.Boolean(true);
			java.util.Iterator t419 = OCL.impl(t416).iterator();
			while (t419.hasNext()) {
			    x = (Collection_)t419.next();
			    IOclSet t420 = OCL.Set(x.getDomainOf());
			    IOclBoolean t421 = (IOclBoolean)t420.includes(self);
			    t418 = t421;
			    if(!OCL.impl(t418)) break;
			}
			log.reportMessage(": "+t418);

		} catch (Exception e) {
			//--- Print result ---
			log.reportMessage(": undefined");
		}
		return null;
	}
}
