/**
 *
 *  Class ConstraintDiagramsRepository.java
 *
 *  Generated by KMFStudio at 22 May 2003 20:32:41
 *  Visit http://www.cs.ukc.ac.uk/kmf
 *
 */

package uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.repository;

import java.util.List;

import javax.swing.tree.DefaultMutableTreeNode;

import uk.ac.ukc.cs.kmf.util.ILog;
import uk.ac.ukc.cs.studio.rwd.ConstraintDiagrams.ConstraintDiagramsFactory;

public interface ConstraintDiagramsRepository
{
	//--- POPULATION ---
	/** Build an element */
	public Object buildElement(String fullClassName);
	/** Add an element */
	public void addElement(String fullClassName, Object elem);
	/** Remove an element */
	public void removeElement(String fullClassName, Object elem);
	/** Get all elements of a given type */
	public List getElements(String fullClassName);
	/** Get all instances of a given type */
	public List getInstances(String fullClassName);

	///--- FACTORIES ---
	/** Get a specific factory */
	public ConstraintDiagramsFactory getFactory(String fullClassName);
	/** Register a factory */
	public void registerFactory(String fullClassName, ConstraintDiagramsFactory factory);

	//--- BROWSER ---
	/** Get the content of the repository */
	public DefaultMutableTreeNode toJTree();
	/** Save the repository into an XMI file */
	public void saveXMI(String fileName);
	/** Create a new repository from an XMI file */
	public ConstraintDiagramsRepository loadXMI(String fileName);
	/** Get the content of the repository */
	public String toHUTN();
	/** Save the repository into an HUTN file */
	public void saveHUTN(String fileName);
	/** Create a new repository from an HUTN file */
	public ConstraintDiagramsRepository loadHUTN(String fileName);

	/** Parse all invariants */
	public void parseInvariants();
	/** Evaluate all invariants */
	public void evaluateInvariants();
	/** Get the log file */
	public ILog getLog();
	/** Set the log file */
	public void setLog(ILog log);
}
