/*
 * AssociationLifecycle.java
 *
 * Created on 28 September 2002
 */

package lifecycle;

import uk.ac.ukc.cs.kmf.studio.vsml.AS.Association;
import uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd;
import uk.ac.ukc.cs.kmf.studio.vsml.repository.VsmlRepository;

/**
 *
 * @author  sjhk
 */
public class AssociationLifecycle extends uk.ac.ukc.cs.kmf.studio.vsml.AS.Association$Factory$Class {
    
    /** Creates a new instance of AssociationEndLifecycle */
    protected AssociationLifecycle() {
        super();
    }

    public AssociationLifecycle(VsmlRepository rep) {
        setRepository(rep);
    }
   
    //one end
    String path = "uk.ac.ukc.cs.kmf.studio.";
    public Association build(
    		uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ p,
        	uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ source, uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ target,
        	String name, Integer lowerBound, Integer upperBound){
        Association assoc = (Association)build();
        lifecycle.AssociationEndLifecycle end_b = (lifecycle.AssociationEndLifecycle)(repository.getFactory(path+"vsml.AS.AssociationEnd"));
        AssociationEnd end = (AssociationEnd) end_b.build(source, target, name, lowerBound, upperBound);

        end.setOtherEnd(null);
        end.setOwner(assoc);
        assoc.getAssociationEnd().add(end);
        if (p!=null) p.getAssociation().add(assoc);
        assoc.setOwner(p);
        return assoc;
    }

    //two ends        
    public Association build(
    		uk.ac.ukc.cs.kmf.studio.vsml.AS.Package_ p,
        	uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ one_class, uk.ac.ukc.cs.kmf.studio.vsml.AS.Class_ other_class,
        	String one_name, Integer one_lowerBound, Integer one_upperBound,
        	String other_name, Integer other_lowerBound, Integer other_upperBound){
        Association assoc = (Association)build();
        lifecycle.AssociationEndLifecycle end_b = (lifecycle.AssociationEndLifecycle)(repository.getFactory("uk.ac.ukc.cs.kmf.studio.vsml.AS.AssociationEnd"));
        AssociationEnd one_end = (AssociationEnd)end_b.build(one_class, other_class, one_name, one_lowerBound, one_upperBound);
        AssociationEnd other_end = (AssociationEnd)end_b.build(other_class, one_class, other_name, other_lowerBound, other_upperBound);

        other_end.setOtherEnd(one_end);
        one_end.setOtherEnd(other_end);
        other_end.setOwner(assoc);
        one_end.setOwner(assoc);
        assoc.getAssociationEnd().add(one_end);
        assoc.getAssociationEnd().add(other_end);
        if (p!=null) p.getAssociation().add(assoc);
        assoc.setOwner(p);
        assoc.setName("");
        return assoc;
    }
}
